About
-----

Bikini is a self-contained, SQLite-based, minimalist wiki engine which runs as Python CGI and FastCGI scripts.

Bikini supports several typical wiki features like: 

* Multiple page revisions
* Recent changes listing (including an Atom feed version)
* Needed pages
* Unlinked pages

Bikini uses Creole syntax to edit contents and includes a SmartyPants processor to beautify content typography.


Requirements
------------

Bikini requires Python 2.5+ and runs on Apache 2. It has been successfully run on other web servers too. FastCGI mode requires Flup (http://pypi.python.org/pypi/flup).


Setup
-----

To run Bikini as CGI script (the most common deploy solution) please follow these steps:

1. Copy all the files - including the hidden .htaccess file - in the root of your web site or in a sub-folder (e.g. "notes"). The folder must be script-writable
2. Make sure the file index.cgi is executable. If not, issue a "chmod 755 index.cgi"
3. Run the bootstrap script called 'setup.py' to create the database file
4. Copy or rename the 'etc/config-sample' file into 'etc/config'
5. Point your browser to the correct URI (e.g. http://yourserver.tld/notes/)

If everything has been set up correctly you should see the FrontPage.

Please refer to http://lab.passiomatic.com/bikini/Setup for updated setup and troubleshooting information.

History
-------

### 2.0.0-dev

  * Total rewrite of app code to comply with WSGI specification. Now Bikini runs in CGI and FastCGI environments, and potentially any WSGI-compatible server software
  * Brand new SQLite single database file

### 1.2.1

  * Fixed invalid Atom feed
  * Fix for issue #17: mobile navigation cannot take user to FrontPage
  * Added PageName/diff shortcut: show diff between current and previous revision
  * Styled more HTML elements to match new theme
  * More detailed feedback messages after page saving
  * Added CSS styling hook to body element
  
### 1.2.0

  * Completely redesigned UI
  * New dedicated WikiWord/revisions page
  * Various bug fixes and performance tweaks

### 1.1.0
 
  * Page URI fragments (e.g. #s-heading-title) for each h2 heading for easy linking
  * Keyboard shortcuts for "edit", "view source" and "about" actions 
  * Group consecutive changes for the same page in RecentChanges lists
  * Added Configuration, WikiWord and SmartyPants documentation pages
  * Various user interface tweaks
  * Bug fixes

### 1.0.0 

  * Fine tuned CSS code to support all Creole 1.0 elements
  * Proper title values for all pages
  * Faster setup process: out of the box initial FrontPage, demo page for Creole syntax and default configuration values
  * Sensible defaults for content caching in .htaccess (off by default)
  * Removed conflicts between Creole optional syntax extensions and SmartyPants
  * Added printer-friendly stylesheet

### 0.9.0 
 
  * First release

